<?xml version="1.0" encoding="UTF-8"?>
<beans xmlns="http://www.springframework.org/schema/beans" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:tx="http://www.springframework.org/schema/tx" xmlns:aop="http://www.springframework.org/schema/aop"
	xsi:schemaLocation="
    http://www.springframework.org/schema/beans
    http://www.springframework.org/schema/beans/spring-beans-3.0.xsd
    http://www.springframework.org/schema/tx 
    http://www.springframework.org/schema/tx/spring-tx-3.0.xsd
    http://www.springframework.org/schema/aop
    http://www.springframework.org/schema/aop/spring-aop-3.0.xsd">
	
	<bean id="sequenceChimieDAO" class="org.inra.ecoinfo.glacpe.dataset.chimie.jpa.JPASequenceChimieDAO" parent="abstractDAO" />
	<bean id="valeurMesureChimieDAO" class="org.inra.ecoinfo.glacpe.dataset.chimie.jpa.JPAValeurMesureChimieDAO" parent="abstractDAO" />

	<bean id="chimieDAO" class="org.inra.ecoinfo.glacpe.dataset.chimie.jpa.JPAChimieDAO" parent="abstractDAO">
		<property name="datatypeStatisticsDAO">
			<bean class="org.inra.ecoinfo.glacpe.dataset.chimie.jpa.JPAChimieDAO$JPADatatypeStatisticsDAO" parent="abstractJPAProjectSpecificDatatypeStatisticsDAO"/>
		</property>	
	</bean>
	<bean id="groupeVariableBuilder" class="org.inra.ecoinfo.glacpe.refdata.groupevariable.DefaultGroupeVariableBuilder" scope="prototype"/>
	
	<bean id="chimieDatatypeManager" class="org.inra.ecoinfo.glacpe.dataset.chimie.impl.DefaultChimieDatatypeManager" parent="MO" >
		<property name="chimieDAO" ref="chimieDAO"/>	
		<property name="variableDAO" ref="variableDAO"/>			
	</bean>	
	
	<bean id="abstractChimieRawsDatasOutputBuilder" class="org.inra.ecoinfo.glacpe.dataset.chimie.impl.AbstractChimieRawsDatasOutputBuilder" parent="abstractOutputBuilder" abstract="true">
		<property name="variableDAO" ref="variableDAO"/>	
		<property name="valeurMesureChimieDAO" ref="valeurMesureChimieDAO"/>
		<property name="datatypeVariableUniteDAO" ref="datatypeVariableUniteDAO"/>
	</bean>
	
	<bean id="abstractChimieRawsDatasExtractor" class="org.inra.ecoinfo.glacpe.dataset.chimie.impl.AbstractChimieRawsDatasExtractor" parent="abstractExtractor" abstract="true">
		<property name="chimieDAO" ref="chimieDAO"/>		
	</bean>
	
	<bean id="chimieRawsDatasExtractor" class="org.inra.ecoinfo.glacpe.dataset.chimie.impl.ChimieRawsDatasExtractor" parent="abstractChimieRawsDatasExtractor"/>
	<bean id="chimieRawsDatasOutputBuilderByLine" class="org.inra.ecoinfo.glacpe.dataset.chimie.impl.ChimieRawsDatasOutputBuilderByLine" parent="abstractChimieRawsDatasOutputBuilder"/>
	<bean id="chimieRawsDatasOutputBuilderByRow" class="org.inra.ecoinfo.glacpe.dataset.chimie.impl.ChimieRawsDatasOutputBuilderByRow" parent="abstractChimieRawsDatasOutputBuilder"/>
	
	<bean id="chimieAggregatedDatasOutputBuilder" class="org.inra.ecoinfo.glacpe.dataset.chimie.impl.ChimieAggregatedDatasOutputBuilder" parent="abstractGLACPEAggregatedDatasOutputBuilder">
		<property name="datatypeVariableUniteDAO" ref="datatypeVariableUniteDAO"/>
	</bean>
	
	<bean id="chimieMeanDatasOutputBuilder" class="org.inra.ecoinfo.glacpe.dataset.chimie.impl.ChimieMeanDatasOutputBuilder" parent="abstractGLACPEAggregatedDatasOutputBuilder">
		<property name="datatypeVariableUniteDAO" ref="datatypeVariableUniteDAO"/>
	</bean>
	
	<bean id="chimieAggregatedDatasExtractor" class="org.inra.ecoinfo.glacpe.dataset.chimie.impl.ChimieAggregatedDatasExtractor" parent="abstractGLACPEAggregatedDatasExtractor">
		<property name="chimieDAO" ref="chimieDAO"/>		
	</bean>
	
	<bean id="chimieRequestReminderOutputBuilder" class="org.inra.ecoinfo.glacpe.dataset.chimie.impl.ChimieRequestReminderOutputBuilder" parent="abstractOutputBuilder"/>

	<bean id="physicoChimieExtractor" class="org.inra.ecoinfo.glacpe.dataset.chimie.impl.DefaultChimieExtractor" parent="MO">
		<property name="chimieRawsDatasExtractor" ref="chimieRawsDatasExtractor"/>
		<property name="chimieAggregatedDatasExtractor" ref="chimieAggregatedDatasExtractor"/>	
	</bean>
	<bean id="physicoChimieOutputBuilderByLine" class="org.inra.ecoinfo.glacpe.dataset.chimie.impl.ChimieOutputBuilderByLine">
		<property name="configuration" ref="coreConfiguration" />
		<property name="chimieAggregatedDatasOutputBuilder" ref="chimieAggregatedDatasOutputBuilder"/>
		<property name="chimieMeanDatasOutputBuilder" ref="chimieMeanDatasOutputBuilder"/>
		<property name="requestReminderOutputBuilder" ref="chimieRequestReminderOutputBuilder"/>
		<property name="chimieBuildOutputByLine" ref="chimieRawsDatasOutputBuilderByLine"/>
		<property name="fileCompConfiguration" ref="fileCompConfiguration" />
		<property name="physicoChimieOutputBuilderSandre" ref="physicoChimieOutputBuilderSandre" />
	</bean>
	<bean id="physicoChimieOutputBuilderByRow" class="org.inra.ecoinfo.glacpe.dataset.chimie.impl.ChimieOutputBuilderByRow">
		<property name="configuration" ref="coreConfiguration" />
		<property name="chimieAggregatedDatasOutputBuilder" ref="chimieAggregatedDatasOutputBuilder"/>
		<property name="chimieMeanDatasOutputBuilder" ref="chimieMeanDatasOutputBuilder"/>
		<property name="requestReminderOutputBuilder" ref="chimieRequestReminderOutputBuilder"/>
		<property name="chimieBuildOutputByRow" ref="chimieRawsDatasOutputBuilderByRow"/>
		<property name="fileCompConfiguration" ref="fileCompConfiguration" />
		<property name="physicoChimieOutputBuilderSandre" ref="physicoChimieOutputBuilderSandre" />
	</bean>
	
        <bean id="physicoChimieOutputBuilderSandre" class="org.inra.ecoinfo.glacpe.dataset.chimie.impl.PhysicoChimieOutputBuilderSandre" parent="abstractChimieRawsDatasOutputBuilder"/>
	
        
	<!-- Recorder Chimie -->
	
	<bean id="publicationChimieDAO" class="org.inra.ecoinfo.glacpe.dataset.chimie.jpa.JPAPublicationChimieDAO" />
	
	<bean id="testValuesChimie" class="org.inra.ecoinfo.glacpe.dataset.impl.GenericTestValues"
		parent="genericTestValues">
	</bean>
	<bean id="testHeadersChimie" class="org.inra.ecoinfo.glacpe.dataset.impl.GenericTestHeader"
		parent="genericTestHeaders">
	</bean>
	
	<bean id="testFormatChimie" class="org.inra.ecoinfo.glacpe.dataset.impl.GenericTestFormat"
		parent="abstractTestFormat">
		<property name="datatypeName" value="physico_chimie" />
		<property name="testValues" ref="testValuesChimie" />
		<property name="testHeaders" ref="testHeadersChimie" />
	</bean>
	
	<bean id="deleteRecordChimie" class="org.inra.ecoinfo.glacpe.dataset.impl.DeleteRecord"
		parent="deleteRecord">
		<property name="publicationDAO" ref="publicationChimieDAO" />
	</bean>
	
	<bean id="processRecordChimie" class="org.inra.ecoinfo.glacpe.dataset.chimie.impl.ProcessRecord"
		parent="abstractProcessRecord">
		<property name="sequenceChimieDAO" ref="sequenceChimieDAO" />
		<property name="outilsMesureDAO" ref="outilsMesureDAO" />
		<property name="projetSiteDAO" ref="projetSiteDAO" />
		<property name="plateformeDAO" ref="plateformeDAO" />
		<property name="controleCoherenceDAO" ref="controleCoherenceDAO" />
	</bean>
	
	<bean id="chimieRecorder" class="org.inra.ecoinfo.glacpe.dataset.impl.RecorderGLACPE">
		<property name="datasetDescriptorPath" value="chimie/dataset-descriptor.xml" />
		<property name="testFormat" ref="testFormatChimie" />
		<property name="deleteRecord" ref="deleteRecordChimie" />
		<property name="processRecord" ref="processRecordChimie" />
		<property name="localizationManager" ref="localizationManager" />
	</bean>
</beans>
